package nl.nikhef.safaripark.extra;

import java.awt.Component;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JToolBar;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;

public final class GuiUtils {

	private GuiUtils() {};
	
	public static final void toolbarTextButton(JButton button) 
	{
		button.setBorder(BorderFactory.createEmptyBorder(4,4,4,4));
		button.setHideActionText(false);
		button.setHorizontalTextPosition(SwingConstants.TRAILING);
		button.setVerticalTextPosition(SwingConstants.CENTER);
	}

	public static final void toolbarTextButtions(JToolBar tb)
	{
		
		for (Component c: tb.getComponents())
		{
			if (c instanceof JButton) {
				toolbarTextButton(JButton.class.cast(c));
			}
		}
		
	}

	private static class StatefulRunner implements Runnable
	{
		
		private StatefulTask _task;

		public StatefulRunner(StatefulTask task) {
			_task = task;
		}

		@Override
		public void run() {
			if (_task.execute()) return;
			SwingUtilities.invokeLater(this);	
		}
				
		
	}
	
	public static void executeStatefulTask(final StatefulTask cloneTask) 
	{
		SwingUtilities.invokeLater(new StatefulRunner(cloneTask));		
	}
	
}
